org.vishia.gral.swt

## Class SwtTextBox

- java.lang.Object
- - org.vishia.gral.base.GralWidget.ImplAccess
  - - org.vishia.gral.base.GralTextField.GraphicImplAccess
    - - org.vishia.gral.base.GralTextBox.GraphicImplAccess
      - - org.vishia.gral.swt.SwtTextBox

- All Implemented Interfaces:
    GralWidgImpl_ifc

      public class SwtTextBox
      extends GralTextBox.GraphicImplAccess

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `SwtTextBox.TextBoxKeyListener`
    `protected class` | `SwtTextBox.TextBoxModifyListener`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected org.eclipse.swt.events.FocusListener` | `focusLstn`
    `(package private) org.eclipse.swt.widgets.Label` | `promptSwt` A possible prompt for the text field or null.
    `static java.lang.String` | `sVersion` Version and history 2014-08-16 Hartmut chg: GralTextBox not abstract, using GraphicImplAccess like new concept of all GralWidgets.
    `private SwtTextFieldWrapper` | `swtText` Experience: use SwtTextFieldWrapper as composite?
    `(package private) org.eclipse.swt.widgets.Text` | `textFieldSwt`
    `private SwtWidgetHelper` | `wdgh` It contains the association to the swt widget (Control) and the `SwtMng` and implements some methods of `GralWidgImpl_ifc` which are delegate from this.

    - ### Fields inherited from class org.vishia.gral.base.GralTextBox.GraphicImplAccess

      `chgAddText, chgCursor, chgEditable, chgNonEditable, chgViewTrail`

    - ### Fields inherited from class org.vishia.gral.base.GralTextField.GraphicImplAccess

      `chgPrompt, posField, posPrompt`

    - ### Fields inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `chgBitsDerived, chgColorBack, chgColorLine, chgColorText, chgFloat, chgFocus, chgFont, chgIntg, chgInvisible, chgObjects, chgPos, chgText, chgVisible, chgVisibleInfo, pixBounds, wdgimpl, widgg`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SwtTextBox(GralTextBox widgg, SwtMng mng)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `(package private) static void` | `createTextBox(GralTextBox widgg, SwtMng mng)`
    `GralRectangle` | `getPixelPositionSize()`
    `java.lang.Object` | `getWidgetImplementation()` Returns the implementation class of the widget.
    `void` | `removeWidgetImplementation()` Removes the graphical widget in the graphic.
    `void` | `repaintGthread()` This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
    `void` | `setBoundsPixel(int x, int y, int dx, int dy)`
    `boolean` | `setFocusGThread()` Sets the focus to the widget.
    `void` | `setVisibleGThread(boolean bVisible)` Sets the implementation widget(s) visible state.

    - ### Methods inherited from class org.vishia.gral.base.GralTextBox.GraphicImplAccess

      `caretPos, caretPos, getAndClearNewText, user`

    - ### Methods inherited from class org.vishia.gral.base.GralTextField.GraphicImplAccess

      `borderwidth, isPasswordField, prompt, promptStylePosition, setTouched`

    - ### Methods inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `acknChanged, actionShow, dyda, getActionChange, getChanged, gralWidgetFromImplData, setDragEnable, setDropEnable, setFocused, setTextChanged, setVisibleState, XXXfocusGained`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sVersion

          public static final java.lang.String sVersion

      Version and history
      - 2014-08-16 Hartmut chg: GralTextBox not abstract, using GraphicImplAccess like new concept of all GralWidgets.
      - 2012-01-06 Hartmut chg: The `GralTextBox.append(CharSequence)` etc. methods are implemented in this super class instead in the graphic layer implementation classes. Therefore the methods `#appendTextInGThread(CharSequence)` and `#setTextInGThread(CharSequence)` are defined here to implement in the graphic layer. The set- and apppend methods are threadsafe now.
      Copyright/Copyleft: For this source the LGPL Lesser General Public License, published by the Free Software Foundation is valid. It means:
      1. You can use this source without any restriction for any desired purpose.
      2. You can redistribute copies of this source to everybody.
      3. Every user of this source, also the user of redistribute copies with or without payment, must accept this license for further using.
      4. But the LPGL is not appropriate for a whole software product, if this source is only a part of them. It means, the user must publish this part of source, but don't need to publish the whole source of the own product.
      5. You can study and modify (improve) this source for own using or for redistribution, but you have to license the modified sources likewise under this LGPL Lesser General Public License. You mustn't delete this Copyright/Copyleft inscription in this source file.
      If you are indent to use this sources without publishing its usage, you can get a second license subscribing a special contract with the author.
      See Also:
        Constant Field Values

    - #### swtText

          private SwtTextFieldWrapper swtText

      Experience: use SwtTextFieldWrapper as composite? (instead superclass)

    - #### wdgh

          private final SwtWidgetHelper wdgh

      It contains the association to the swt widget (Control) and the `SwtMng` and implements some methods of `GralWidgImpl_ifc` which are delegate from this.

    - #### textFieldSwt

          org.eclipse.swt.widgets.Text textFieldSwt

    - #### promptSwt

          org.eclipse.swt.widgets.Label promptSwt

      A possible prompt for the text field or null.

    - #### focusLstn

          protected org.eclipse.swt.events.FocusListener focusLstn

  - ### Constructor Detail

    - #### SwtTextBox

          protected SwtTextBox(GralTextBox widgg,
                               SwtMng mng)

  - ### Method Detail

    - #### createTextBox

          static void createTextBox(GralTextBox widgg,
                                    SwtMng mng)

    - #### getPixelPositionSize

          public GralRectangle getPixelPositionSize()

    - #### getWidgetImplementation

          public java.lang.Object getWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Returns the implementation class of the widget. If the widget has more as one implementation widgets, this method returns one of the widgets, usual the first important one respectively that widget which represents the implementation layer. A widget of the implementation layer is a SWT.control or a `Component`.
      If more as one widget are part of the GralWidget, use the special `GralWidget._wdgImpl` class which should contain the references to that implementation widgets.

    - #### setBoundsPixel

          public void setBoundsPixel(int x,
                                     int y,
                                     int dx,
                                     int dy)

    - #### repaintGthread

          public void repaintGthread()

      Description copied from interface: `GralWidgImpl_ifc`
      This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
      Implementation hints: In SWT it should call redraw().
      It is possible that the widget consists of more as one graphical widget, then all of it should be redrawn. It is possible that some data are set in another thread, they should be applied to the widgets firstly. It is possible that the widget is removed though a repaintGthread-order is pending from the time before deleting, for example if the graphic layout is changed.
      See `#repaintRequ`

    - #### setFocusGThread

          public boolean setFocusGThread()

      Description copied from interface: `GralWidgImpl_ifc`
      Sets the focus to the widget. See `GralMng_ifc#setFocus(GralWidget)`.
      Returns:
        true if it has the focus after this operation. false on any error.

    - #### setVisibleGThread

          public void setVisibleGThread(boolean bVisible)

      Description copied from interface: `GralWidgImpl_ifc`
      Sets the implementation widget(s) visible state. The widgets are really invisible, or they are visible in principle, but they can be covered by other windows or clipping. This method should set the `GralWidget.bVisibleState` too. Therewith it is able to quest `GralWidget.isVisible()` in any thread.
      Parameters:
        `bVisible` - true then the widget should be visible, false it is set to invisible.

    - #### removeWidgetImplementation

          public void removeWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Removes the graphical widget in the graphic.